; Sweet DFLI C16 Startup by gerliczer
; programmed on 2016-12-25, updates on 2018-01-04
; created with Csabo's Plus4IDE 1.70 and
; Frank A. Kingswood's AS65 1.42
; upload only to strictly CBM264 series related sites
; PAL only program, 16kB memory required

BORDER_FADE_NORMALIZE	equ	0

	org $1001-2
	dw  $1001
	
	dw nextln, 2018	; second word is line number
	db $9E
	if start > 9999
	db "0"+start/10000
	endif
	db "0"+(start/1000)%10,"0"+(start/100)%10,"0"+(start/10)%10,"0"+start%10,0
nextln	db 0,0
	
start
	sei
	sta $FF3F
	jsr fadeBorder	; fading border
	jsr flushScreen	; clearing screen
	jsr closeScreen
	jsr checkSystem
isPal
 	lda #0
 	if NON_PAL
 	bne quit
 	else
	beq quit
	endif
	jmp dataStart+2
quit
	sta $FF3E
	jmp $FFF6

; Fading border colour to black in an increasing delay fashion.
fadeBorder
	lda $FF19	; check if border color is black
	and #$0F
	cmp #0
	beq exitFadeBorder
loopFadeBorder
	ldx #2		; delay colour change
waitFadeBorderDelay
	lda #$FF
	cmp $FF1D
	bne *-3
	cmp $FF1D
	beq *-3
	dex
	bne waitFadeBorderDelay
	inc loopFadeBorder+1
	if BORDER_FADE_NORMALIZE
	lda loopFadeBorder+1
	and #$F0
	bne skipNormalizeDelay
	lda #7
skipNormalizeDelay
	sta loopFadeBorder+1
	endif
	lda $FF19	; decrease shade
	sec
	sbc #$10
	sta $FF19
	and #$70	; check if already darkest
	bne loopFadeBorder
	lda #0
	sta $FF19
exitFadeBorder
	rts

; Flush screen to black from left to right with delay between rows.
flushScreen
	ldy #65
flushScreenCycle
	ldx #2
waitFlushScreenCycle
	lda #$FF
	cmp $FF1D
	bne *-3
	cmp $FF1D
	beq *-3
	dex
	bne waitFlushScreenCycle
flushVariableAccess
	inc flushRowPositions
	ldx flushRowPositions
	bmi skipFlushRow
	cpx #40
	beq skipFlushRow
	lda #0
flushScreenLuma
	sta $0800,x
	lda #160
flushScreenChroma
	sta $0C00,x
skipFlushRow
	lda flushVariableAccess+1
	cmp #lo(flushRowPositions+24)
	beq resetFlushPointers 
	inc flushVariableAccess+1
	inc flushVariableAccess+4
	lda flushScreenLuma+1
	clc
	adc #$28
	sta flushScreenLuma+1
	sta flushScreenChroma+1
	bcc skipHiByteIncrement
	inc flushScreenLuma+2
	inc flushScreenChroma+2
skipHiByteIncrement
	jmp flushVariableAccess
resetFlushPointers
	lda #lo(flushRowPositions)
	sta flushVariableAccess+1
	sta flushVariableAccess+4
	lda #$08
	sta flushScreenLuma+2
	lda #$0C
	sta flushScreenChroma+2
	lda #0
	sta flushScreenLuma+1
	sta flushScreenChroma+1
	dey
	bne flushScreenCycle
	rts

flushRowPositions
	db  -1,  -2,  -3,  -4,  -5,  -6,  -7,  -8
	db  -9, -10, -11, -12, -13, -14, -15, -16
	db -17, -18, -19, -20, -21, -22, -23, -24
	db -25

closeScreen
	lda #$FF
	cmp $FF1D
	bne *-3
	lda #07
	sta $FF06
	rts

checkSystem
	lda #$FF
waitScreenTop
	cmp $FF1C
	bne waitScreenTop
	lda #$FE
waitScreenStart
	cmp $FF1C
	bne waitScreenStart
	lda #$FF
waitScreenTop2
	cmp $FF1C
	bne waitScreenTop2
readRaster
	ldx $FF1D
	txa
waitNextRaster
	cpx $FF1D
	beq waitNextRaster
	ldx $FF1D
	bne readRaster
	and #$20
	sta isPal+1
	rts

dataStart	equ	*

	end
